version: 2

models:
  - name: gitlab_dotcom_audit_event_details_clean
    description: All gitlab dotcom audit event details, with pii replaced with hashes
    columns:
      - name: audit_event_id
        tests:
          - not_null
      - name: key_name
        tests:
          - not_null
      - name: key_value
      - name: updated_at
        tests:
          - not_null
        
  - name: gitlab_dotcom_clusters_applications_cert_managers_xf
    columns:
      - name: clusters_applications_cert_managers_id
        tests:
          - not_null
          - unique
      - name: cluster_id
        tests:
          - not_null

  - name: gitlab_dotcom_clusters_applications_crossplane_xf
    columns:
      - name: clusters_applications_crossplane_id
        tests:
          - not_null
          - unique
      - name: cluster_id
        tests:
          - not_null

  - name: gitlab_dotcom_clusters_applications_elastic_stacks_xf
    columns:
      - name: clusters_applications_elastic_stacks_id
        tests:
          - not_null
          - unique
      - name: cluster_id
        tests:
          - not_null

  - name: gitlab_dotcom_clusters_applications_helm_xf
    columns:
      - name: clusters_applications_helm_id
        tests:
          - not_null
          - unique
      - name: cluster_id
        tests:
          - not_null

  - name: gitlab_dotcom_clusters_applications_ingress_xf
    columns:
      - name: clusters_applications_ingress_id
        tests:
          - not_null
          - unique
      - name: cluster_id
        tests:
          - not_null

  - name: gitlab_dotcom_clusters_applications_jupyter_xf
    columns:
      - name: clusters_applications_jupyter_id
        tests:
          - not_null
          - unique
      - name: cluster_id
        tests:
          - not_null

  - name: gitlab_dotcom_clusters_applications_knative_xf
    columns:
      - name: clusters_applications_knative_id
        tests:
          - not_null
          - unique
      - name: cluster_id
        tests:
          - not_null

  - name: gitlab_dotcom_clusters_applications_prometheus_xf
    columns:
      - name: clusters_applications_prometheus_id
        tests:
          - not_null
          - unique
      - name: cluster_id
        tests:
          - not_null

  - name: gitlab_dotcom_clusters_applications_runners_xf
    columns:
      - name: clusters_applications_runners_id
        tests:
          - not_null
          - unique
      - name: cluster_id
        tests:
          - not_null

  - name: gitlab_dotcom_clusters_xf
    columns:
      - name: cluster_id
        tests:
          - not_null
          - unique

  - name: gitlab_dotcom_daily_usage_data_events_90
    description: '{{ doc("gitlab_dotcom_daily_usage_data_events_90") }}'
    columns:
      - name: event_name
        tests:
          - not_null
      - name: stage_name
        tests:
          - not_null
      - name: is_representative_of_stage
        tests:
          - not_null
        description: This column represents whether or not this action represents being active for the entire stage. One action per stage has this designation.
      - name: event_date
        tests:
          - not_null

  - name: gitlab_dotcom_daily_usage_data_events
    description: '{{ doc("gitlab_dotcom_daily_usage_data_events") }}'
    columns:
      - name: event_name
        tests:
          - not_null
      - name: stage_name
        tests:
          - not_null
      - name: is_representative_of_stage
        tests:
          - not_null
        description: This column represents whether or not this action represents being active for the entire stage. One action per stage has this designation.
      - name: event_date
        tests:
          - not_null
  - name: gitlab_dotcom_environments_xf
    description: '{{ doc("gitlab_dotcom_environments_xf") }}'
    columns:
      - name: environment_id
        tests:
          - not_null
          - unique
      - name: project_id
        tests:
          - not_null
      - name: environment_name
        tests:
          - not_null
  - name: gitlab_dotcom_gitlab_user_requests
    description: '{{ doc("gitlab_dotcom_gitlab_user_requests") }}'
    tests:
    - unique:
        column_name: "concat(noteable_type, noteable_id, mention_type, sfdc_account_id)"
    columns:
      - name: noteable_id
        tests:
          - not_null
      - name: noteable_type
        tests:
          - not_null
      - name: namespace_id
        tests:
          - not_null
      - name: sfdc_account_id
        tests:
          - not_null
     
  - name: gitlab_dotcom_gitlab_user_requests_opportunities
    description: '{{ doc("gitlab_dotcom_gitlab_user_requests_opportunities") }}'
    columns:
      - name: noteable_id
        tests:
          - not_null
      - name: noteable_type
        tests:
           - not_null
      - name: sfdc_account_id
        tests:
          - not_null
      - name: sfdc_opportunity_id
        tests:
          - not_null                    

  - name: gitlab_dotcom_internal_notes_xf
    description: '{{ doc("gitlab_dotcom_internal_notes_xf") }}'
    columns:
      - name: note_id
        tests:
          - not_null
          - unique
      - name: created_at
        tests:
          - not_null
      - name: updated_at
        tests:
          - not_null
      - name: noteable_type
        tests:
          - accepted_values:
                      values: ['Commit', 'Epic', 'Issue', 'MergeRequest', 'Snippet', 'Wiki', 'DesignManagement::Design']

  - name: gitlab_dotcom_issues_xf
    description: '{{ doc("gitlab_dotcom_issues_xf") }}'
    columns:
      - name: issue_id
        tests:
          - not_null
      - name: state
        tests:
          - not_null
          - accepted_values:
              values: ['opened', 'closed', 'merged', 'locked']
      - name: issue_title
        description: '{{ doc("xf_visibility_documentation") }}'
      - name: issue_description
        description: '{{ doc("xf_visibility_documentation") }}'
      - name: namespace_plan_id_at_issue_creation
        description: '{{ doc("namespace_plan_id_at_creation") }}'

  - name: gitlab_dotcom_label_states_xf
    description: Represents the latest state (added or removed) for each label on Epics/Issues/Merge Requests. Should be phased out in favor of `label_links`.
    columns:
      - name: label_id
        tests:
          - not_null

  - name: gitlab_dotcom_labels_xf
    description: '{{ doc("gitlab_dotcom_labels_xf") }}'
    columns:
      - name: label_id
        tests:
          - not_null
      - name: masked_label_title
        description: '{{ doc("xf_visibility_documentation") }}'

  - name: gitlab_dotcom_groups_xf
    description: '{{ doc("gitlab_dotcom_groups_xf") }}'
    columns:
      - name: group_id
        tests:
          - not_null
          - unique
      - name: group_plan_is_paid
        description: Whether or not the group is subscribed to a paid plan. A subgroup inherits from the subscription of its ultimate parent group
      - name: member_count
        description: The number of members that are presently associated with the group.
      - name: project_count
        description: The number of projects that are presently associated with the group.
  - name: gitlab_dotcom_memberships
    description: '{{ doc("gitlab_dotcom_memberships") }}'
    tests:
      - unique:
          column_name: "concat(membership_source_type, '_', membership_source_id, '_', user_id)"
    columns:
      - name: ultimate_parent_id
        tests:
          - not_null
      - name: namespace_id
        tests:
          - not_null
      - name: user_id
        tests:
          - not_null
      - name: access_level
        tests:
          - not_null
      - name: membership_source_type
        description: This describes how the access is being granted ('group_membership', 'project_membership', 'group_group_links', 'project_group_links').
        tests:
          - not_null
      - name: membership_source_id
        description: The id of the record that is granting the access. If membership_source_type='group_membership', then this is the group_id.
        tests:
          - not_null

  - name: gitlab_dotcom_events_monthly_active_users
    description: '{{ doc("gitlab_dotcom_events_monthly_active_users") }}'
    tests:
      - unique:
          column_name: "concat(day, plan_id_at_event_date)"
    columns:
      - name: day
        tests:
          - not_null
      - name: is_last_day_of_month
        tests:
          - not_null
      - name: count_audit_events_active_users_last_28_days
        description: The number of unique active users (from audit events table) in the previous 28 days (inclusive). 
      - name: count_audit_events_active_users_last_28_days
        description: The number of unique active users (from events table) in the previous 28 days (inclusive). 

  - name: gitlab_dotcom_merge_request_assignment_events
    description: '{{ doc("gitlab_dotcom_merge_request_assignment_events") }}'
    columns:
      - name: merge_request_id
        tests: 
          - not_null

  - name: gitlab_dotcom_merge_requests_merged_authors_xf
    description: This is a dbt model of notes that signify a merge request being merged.
    columns:
      - name: project_id
      - name: namespace_id
      - name: merge_request_iid
        tests: 
          - not_null
      - name: merge_request_title
        tests: 
          - not_null
      - name: merge_request_id
        tests: 
          - not_null
      - name: note_author_id
        tests: 
          - not_null
      - name: user_name
        tests: 
          - not_null

  - name: gitlab_dotcom_merge_requests_xf
    description: '{{ doc("gitlab_dotcom_merge_requests_xf") }}'
    columns:
      - name: merge_request_id
        tests:
          - not_null
      - name: is_community_contributor_related
        description: Merge Request has 'community contribution' tag, and is on a project in the gitlab.org namespace.
      - name: namespace_plan_id_at_merge_request_creation
        description: '{{ doc("namespace_plan_id_at_creation") }}'
  - name: gitlab_dotcom_monthly_stage_active_users
    description: '{{ doc("gitlab_dotcom_monthly_stage_active_users") }}'
    columns:
      - name: event_name
        tests:
          - not_null
      - name: stage_name
        tests:
          - not_null
  - name: gitlab_dotcom_milestones_xf
    description: This is a non-sensitive models of the milestones table. The "title" and "description" columns are masked for non-internal namespaces.
    columns:
      - name: milestone_id
        tests:
          - not_null
          - unique
      - name: milestone_status
        tests:
          - not_null
      - name: milestone_created_at
        tests:
          - not_null
      - name: milestone_updated_at
        tests:
          - not_null
      - name: namespace_id
        description: This is added as a helper column. This is either the group_id (groups are namespaces) or the namespace associated with the milestone's project.


  - name: gitlab_dotcom_namespaces_xf
    description: '{{ doc("gitlab_dotcom_namespaces_xf") }}'
    columns:
      - name: namespace_id
        tests:
          - not_null
          - unique
      - name: namespace_name
        tests:
          - not_null
      - name: namespace_path
        tests:
          - not_null
      - name: namespace_type
        tests:
          - not_null
      - name: plan_id
        description: The **plan_id** associated with the namespace's subscription. This can be inheritted from the namespaces's ultimate parent.
        tests:
          - not_null
          - accepted_values:
              values: ['2', '3', '4', '34', '67', 'trial']
      - name: plan_title
        description: Whether or not the namespace associated with the project is subscribed to a paid plan. This can be inheritted from the namespaces's ultimate parent.
        tests:
          - not_null
      - name: plan_is_paid
        description: Whether or not the namespace associated with the project is subscribed to a paid plan. This can be inheritted from the namespaces's ultimate parent.
        tests:
          - not_null
      - name: member_count
        description: The number of members that are presently associated with the namespace.
      - name: project_count
        description: The number of projects that are presently associated with the namespace.

  - name: gitlab_dotcom_projects_xf
    description: '{{ doc("gitlab_dotcom_projects_xf") }}'
    columns:
      - name: project_id
        tests:
          - not_null
          - unique
      - name: member_count
        description: The number of members that are presently associated with the project.
      - name: active_service_types
        description: The types of services currently active and associated with the project.
      - name: namespace_plan_is_paid
        description: Whether or not the namespace associated with the project is subscribed to a paid plan.
      - name: namespace_plan_id_at_project_creation
        description: '{{ doc("namespace_plan_id_at_creation") }}'

  - name: gitlab_dotcom_resource_label_events_xf
    description: xf model for gitlab_dotcom_resource_milestone_events joining with issues, epics and mrs.
    columns:
        - name: resource_label_event_id
          tests:
            - not_null
            - unique
  - name: gitlab_dotcom_resource_milestone_events_xf
    description: xf model for gitlab_dotcom_resource_milestone_events joining with issues and mrs.
    columns:
        - name: resource_milestone_event_id
          tests:
            - not_null
            - unique
  - name: gitlab_dotcom_resource_weight_events_xf
    description: xf model for gitlab_dotcom_resource_milestone_events joining with issues
    columns:
        - name: resource_weight_event_id
          tests:
            - not_null
            - unique
  - name: gitlab_dotcom_retention_cohorts
    description: '{{ doc("gitlab_dotcom_retention_cohorts") }}'
    columns:
        - name: cohort_key
          description: md5 of cohort date and cohort period in other to provide a unique key
          tests:
            - not_null
            - unique
        - name: cohort_date
          description: Users are cohorted based on the month their account was created on gitlab.com.
          tests:
            - not_null
        - name: period
          description: Length in months of activity period, using the difference between `created_at` and `last_activity_on`.
          tests:
            - not_null
        - name: active_in_period_distinct_count
          description: Count of distinct Users active on this period.
        - name: base_cohort_count
          description: Size of the original cohort.
        - name: retention
          description: Calculated as `active_in_period_distinct_count` / `base_cohort_count`.
  - name: gitlab_dotcom_saml_providers_xf
    description: '{{ doc("gitlab_dotcom_saml_providers_xf") }}'
    columns:
      - name: saml_provider_id
        tests:
          - not_null
          - unique
  - name: gitlab_dotcom_secure_stage_ci_jobs
    description: '{{ doc("gitlab_dotcom_secure_stage_ci_jobs") }}'
    columns:
      - name: ci_build_id
        tests:
          - not_null
          - unique
          
  - name: gitlab_dotcom_usage_data_events
    description: '{{ doc("gitlab_dotcom_usage_data_events") }}'
    columns:
      - name: event_name
        tests:
          - not_null
      - name: stage_name
        tests:
          - not_null
      - name: is_representative_of_stage
        tests:
          - not_null
        description: This column represents whether or not this action represents being active for the entire stage. One action per stage has this designation.
      - name: event_created_at
        tests:
          - not_null
        
  - name: gitlab_dotcom_users_xf
    description: '{{ doc("gitlab_dotcom_users_xf") }}'
    columns:
      - name: user_id
        tests:
          - not_null
          - unique
      - name: days_active
        description: days between user creation and last activity
      - name: account_age_cohort
        description: cohorting of time between last dbt run and user creation date.    
